---
title: WindowClient.navigate()
slug: Web/API/WindowClient/navigate
tags:
  - API
  - Client
  - Experimental
  - Method
  - Navigate
  - Reference
  - Service Workers
  - WindowClient
---
<p>{{APIRef("Service Workers API")}}</p>

<p>The <strong><code>navigate()</code></strong> method of the {{domxref("WindowClient")}} interface loads a specified URL into a controlled client page then returns a {{jsxref("Promise")}} that resolves to the existing {{domxref("WindowClient")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>windowClient</em>.navigate(<em>url</em>).then(function(<em>windowClient</em>) {
  // do something with your WindowClient after navigation
});</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>url</code></dt>
 <dd>The location to navigate to.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that resolves to the existing {{domxref("WindowClient")}}.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#dom-windowclient-navigate', 'navigate()')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.WindowClient.navigate")}}</p>
</div>
